var callbackEvent = (function (callback, timeout, params) { 
	this.callbackSignature = callback.name;
	this.timeout = timeout;
	this.callback = callback;
	this.params = params;
});

callbackEvent.prototype = function() {	
	var isSame = function(other) {
		return this.callbackSignature == other.callbackSignature;
	};		
	
	var expired = function() {
		return this.timeout <= 0;
	};	
	
	var execute = function() {
		this.callback(this.params);
	};	

	var tick = function() {
		this.timeout--;
	};		

  return {
		isSame : isSame,
		expired: expired,
        execute: execute,
		tick: tick
   	
    };
}();

var _deferedEventManager = (function () {

	var events = [];
	var intervalResolution = 250;

	function addAction(name, callback, timeout, params)
	{
		if (events == undefined || events.length == 0)
		{
			setInterval(intervalHandler, intervalResolution);
		}
		
		var cb = new callbackEvent(callback, timeout, params );
		cb.callbackSignature = name;

		for (var i = 0; i < events.length; i++) {
			if (events[i].isSame(cb))
			{
				events[i] = cb;
				return;
			}
		}

		events.push(cb);
	}

   return {
		addAction : addAction
    };

	function intervalHandler(){

		var newEventArray = [];
		for (var i = 0; i < events.length; i++) {
			
			var evt = events[i];
			if (evt.expired())
			{
				evt.execute();	
			}
			else
			{
				evt.tick();
				newEventArray.push(evt);
			}
		}		
			
		events = newEventArray;

		if (events.length == 0)
		{
			clearInterval(intervalHandler);
		}		
	}
	
})();	
