
function AddCellToRow(row, cellText) {
    // Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
    var cell = row.insertCell(-1);
    var cell1Text = cellText;
    var text = document.createTextNode(cell1Text)
    cell.appendChild(text);
}

$(document).on(Event_CharChanged, function(e, hintChar) { 
	if (hintChar)
		UpdateModifiedCell(hintChar);
});


function RefreshModifiedTableImages(index) {
	for(var i=0; i<= 255; i++)
		UpdateModifiedCell(i);
}

function RefreshTableCharCount() {
	for(var i=0; i<= 255; i++)
		UpdateTableCharCount(i);
}

function GetModifiedText(index) {
	return "N";
}

function GetCharUsage(index) {
	if ($("#chkShowAllSceenCharCount").is(":checked"))
	return  _CbmScreenArray.getCharUsageCount(index);
		else
	return  CbmScreen.getCharUsageCount(index);
}

var originalCharBuffer = [];

function getCharUsage(){
	
	var usageArray = [];
	
	// Loop through each character
	for(var c=0; c<= 255; c++){
		
		// Create an object to hold char usage info
		var charUsage = {ScreenInfo:[], ScreenCount:0, OrignalCharIndex:c};
		
		// Loop through each screen
		for(var screen=0; screen <  maxScreens; screen++) {
			// Get usage for screen
			var count = CbmScreens[screen].getCharUsageCount(c);
			charUsage.ScreenInfo[screen] = {usage: count};
			// Tot up the number of screen
			if (count > 0)
				charUsage.ScreenCount++;
		}
		
		usageArray.push(charUsage);
	}
	
	return usageArray;
}

// Organise all chars
$('#organiseTileUseageChars').click(function(e) {
	DoOrganiseTileUseageChars();
});

function DoOrganiseTileUseageChars()
{
	var usageArray = [];

	// Copy current characters
	for(var c=0; c<= 255; c++){
		var cbmChar = uDCGen.getCbmChar(c);
		var clone = cbmChar.clone();
		originalCharBuffer[c]=clone;
	}

	usageArray =  getCharUsageTiles();

  
	// function so sort objects by
	function tileComparer(a,b) {
		
		var aSC = a.UseageCount;
		var bSC = b.UseageCount;

		if (aSC > 1)
			aSC = 1;

		if (bSC > 1)
			bSC = 1;

		if (aSC > bSC)
			return -1;

		if (aSC < bSC)
			return 1;
	  
		// Otherwise order by original index
		if (a.OrignalCharIndex <  b.OrignalCharIndex)
			return -1;

		if (a.OrignalCharIndex >  b.OrignalCharIndex)
			return 1;

	  return 0;
	}

	// Sort objects by screen count
	usageArray = usageArray.sort(tileComparer);

	// Prepare to relocate the characters
	_CbmScreenArray.prepareRelocate();
	_CbmTileSet.prepareRelocate();

	// Copy the characater
	for(var c=0; c < usageArray.length; c++){
		var charToLocate = usageArray[c];
		var targetChar = uDCGen.getCbmChar(c);
		var sourceChar = originalCharBuffer[charToLocate.OrignalCharIndex];
		targetChar.copyFromSource(sourceChar);
		_CbmScreenArray.relocate(charToLocate.OrignalCharIndex, c);
		_CbmTileSet.relocate(charToLocate.OrignalCharIndex, c);
		if (charToLocate.UseageCount == 0)
			targetChar.revert();
	}
	
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);	
	RefreshTableCharCount();
}

function getCharUsageTiles(){
	
	var usageArray = [];
	
	// Loop through each character
	for(var c=0; c<= 255; c++){
		
		// Create an object to hold char usage info
		var count = _CbmTileSet.getCharUsageCount(c);
		var charUsage = {};
		charUsage.UseageCount = count;
		charUsage.OrignalCharIndex = c;
		usageArray.push(charUsage);
	}
	
	return usageArray;
}



// Organise all chars
$('#organiseAllChars').click(function(e) {
	OrganiseScreenChars();
});


function OrganiseScreenChars()
{
	var usageArray = [];

	// Copy current characters
	for(var c=0; c<= 255; c++){
		var cbmChar = uDCGen.getCbmChar(c);
		var clone = cbmChar.clone();
		originalCharBuffer[c]=clone;
	}

	usageArray =  getCharUsage();

	// returns screen in use (assumes only one)
	function getScreen(cu) {
		for(var screen=0; screen < maxScreens; screen++) {
			if (cu.ScreenInfo[screen].usage > 0)
				return screen;
		}
	}
	  
	// function so sort objects by
	function comparer(a,b) {
		
		var aSC = a.ScreenCount;
		var bSC = b.ScreenCount;

		if (aSC > 2)
			aSC = 2;

		if (bSC > 2)
			bSC = 2;

		if (aSC > bSC)
			return -1;

		if (aSC < bSC)
			return 1;
	  
		if (aSC == bSC && bSC == 1){
			// Otherwise order by screen index  
			if (getScreen(a) <  getScreen(b))
				return -1;
			if (getScreen(a) >  getScreen(b))
				return 1;
		}

		// Otherwise order by original index
		if (a.OrignalCharIndex <  b.OrignalCharIndex)
			return -1;
		if (a.OrignalCharIndex >  b.OrignalCharIndex)
			return 1;

	  return 0;
	}

	// Sort objects by screen count
	usageArray = usageArray.sort(comparer);

	// Prepare to relocate the characters
	_CbmScreenArray.prepareRelocate();
	_CbmTileSet.prepareRelocate();

	// Copy the characater
	for(var c=0; c < usageArray.length; c++){
		
		var charToLocate = usageArray[c];
		var targetChar = uDCGen.getCbmChar(c);
		var sourceChar = originalCharBuffer[charToLocate.OrignalCharIndex];
		targetChar.copyFromSource(sourceChar);
		_CbmScreenArray.relocate(charToLocate.OrignalCharIndex, c);
	}
	
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);	
	RefreshTableCharCount();
}

// Organise all chars
$('#organiseAllChars').click(function(e) {
	OrganiseScreenChars();
});





function AddRowToTable(table, screenCode, originalImage, modImage, index, colCode, mc) {

    // Create an empty <tr> element and add it to the 1st position of the table:
    var row = table.insertRow(-1);
	var petscii = (screenCode & 0x7F) + 64;
	var petsciiText = petscii + "($" + petscii.toString(16) + ")";

	AddCellToRow(row, gCurBankOffset + index); 
	AddImageCellToRow(row, 1); 
	AddCellToRow(row, petsciiText.trim());
	AddCellToRow(row, "N");
	AddImageCellToRow(row, 4);
    AddCellToRow(row, "0");
    AddCellToRow(row, "N");
    UpdateModifiedCell(index);
}

function UpdateModifiedCell(index) {

	var table = $("#charTable")[0];
	if (table.rows.length > 1)
	{
		var row = table.rows[index + 1];
		var chr = uDCGen.getCbmChar(index);
		var isMc = chr.IntendedMultiColor ? "Y" : "N";
		var isModifiedText  = chr.isModified() ? "Y" : "N";

		// 0 no Change
		RenderCell(table, index, 1, true);
		// 2 no Change
		$(row.cells[3]).text(isModifiedText);
		RenderCell(table, index, 4, false);
		$(row.cells[6]).text(isMc);
	}
}

function RenderCell(table, rowIdx, cellIdx, useROM) {
	var row = table.rows[rowIdx + 1];
	var cell = row.cells[cellIdx];
	doDrawCharCanvas(tempCanvas, rowIdx, useROM);
	var imageSource = tempCanvas.toDataURL("image/png");
	var img = cell.firstChild;
	img.src = imageSource;
}

function UpdateTableCharCount(index) {

	var table = $("#charTable")[0];
	if (table.rows.length > 1)
	{
		var row = table.rows[index + 1];
		var occurs = GetCharUsage(index);
		var cell = row.cells[5];
		$(cell).text(occurs);
	}
}

function AddImageCellToRow(row, index) {

    // Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
    var cell = row.insertCell(-1);
	doDrawCharCanvas(tempCanvas, index);
	var imageSource = tempCanvas.toDataURL("image/png");
    cell.innerHTML="";
    var img = document.createElement('img');
    img.src = imageSource;
    cell.appendChild(img);
}

function SetTableAttributesFromIntended(mc, colour) {

	/* Get all rows from your 'table' but not the first one 
     * that includes headers. */
     var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			var cbmChar = uDCGen.getCbmChar(index -1);
			cbmChar.IntendedMultiColor = mc;
			cbmChar.IntendedCharColor =  colour;
		}
	});
}

function WireRowClicks() {
    

	/* Get all rows from your 'table' but not the first one 
     * that includes headers. */
    var rows = $('#charTable tr').not(':first');
    
    /* Create 'click' event handler for rows */
    rows.on('click', function(e) {
        
		/* Get current row */
        var row = $(this);
		
		// Show the clicked row
		SetCurCharFocus(this.rowIndex-1);
       
        /* Check if 'Ctrl', 'cmd' or 'Shift' keyboard key was pressed
         * 'Ctrl' => is represented by 'e.ctrlKey' or 'e.metaKey'
         * 'Shift' => is represented by 'e.shiftKey' */
        if ((e.ctrlKey || e.metaKey) || e.shiftKey) {
            /* If pressed highlight the other row that was clicked */
            row.addClass('highlight');
			
			if (e.shiftKey)
			{
				var first = 1000;
				var last = -1;
				for (var r = 0; r < rows.length; r++)
				{
					var hRow = $(rows[r]);
					if (hRow.hasClass('highlight'))
					{
						if ( r < first ) first = r;
						if ( r > last ) last = r;
					}
				}

				// Highlight all intermediate rows with shift.
				for (var r = first; r <= last; r++)
				{
					var hRow = $(rows[r]);
					hRow.addClass('highlight');
				}
			}

        } else {
            /* Otherwise just highlight one row and clean others */
            rows.removeClass('highlight');
            row.addClass('highlight');
        }
		
    });
    
    /* This 'event' is used just to avoid that the table text 
     * gets selected (just for styling). 
     * For example, when pressing 'Shift' keyboard key and clicking 
     * (without this 'event') the text of the 'table' will be selected.
     * You can remove it if you want, I just tested this in 
     * Chrome v30.0.1599.69 */
    $('#charTable').bind('selectstart dragstart', function(e) { 
        e.preventDefault(); return false; 
    });
    
}

function PopulateCharTable() {

	var table = $("#charTable")[0];

	 $("#charTable tbody tr").remove();
    
	// Todo: remove all rows
	for (var i = 0; i <= 255; i++) {
        AddRowToTable(table, i, null, null, i, 0, false);
    }
	
	WireRowClicks();
}

$(document).on(Event_CharSelected, function(e, hintChar) { 
	if (!isNullOrUndefined(hintChar))
		SetCurCharFocus(hintChar);
});

function SetCurCharFocus(rowIndex)
{
	gCurrentCanvasChar = rowIndex ;
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	gIntendedMultiColour = cbmChar.IntendedMultiColor;
	//alert("SetCurCharFocus rowIndex=" + rowIndex + " gIntendedMultiColour =  " + gIntendedMultiColour);
	$('#chkMultiColour').prop('checked', gIntendedMultiColour);
	$('#selectIntendedCharColour').val(cbmChar.IntendedCharColor);
	$('#charIndexSpan').text(gCurrentCanvasChar);
	$('#charUsageCount').text(GetCharUsage(gCurrentCanvasChar));
	RedrawCanvas();
}

function SetCurCharFocusFromScreen(charIndex, mc, col)
{
	gCurrentCanvasChar = charIndex ;
	gIntendedMultiColour = mc;
	//alert("SetCurCharFocus rowIndex=" + rowIndex + " gIntendedMultiColour =  " + gIntendedMultiColour);
	$('#chkMultiColour').prop('checked', mc).triggerHandler('change');
	$('#selectIntendedCharColour').val(col).trigger('change');
	$('#charIndexSpan').text(gCurrentCanvasChar);
	$('#charUsageCount').text(GetCharUsage(gCurrentCanvasChar));
	RedrawCanvas();
}




